/**
 *
 */
package com.wieseke.cptk.common.util;

/**
 * @author Nicolas Wieseke
 * 
 */
public class Tupel<T1, T2> {

	/**
	 * the first value
	 */
	private T1 value1;
	/**
	 * the second value
	 */
	private T2 value2;

	/**
	 * default constructor
	 * 
	 * @param value1
	 * @param value2
	 */
	public Tupel(T1 value1, T2 value2) {
		this.value1 = value1;
		this.value2 = value2;
	}

	/**
	 * @returnb the value1
	 */
	public T1 getValue1() {
		return value1;
	}

	/**
	 * @return the value2
	 */
	public T2 getValue2() {
		return value2;
	}

	/**
	 * @param value1
	 * @return the old value1
	 */
	public T1 setValue1(T1 value1) {
		T1 oldValue1 = this.value1;
		this.value1 = value1;
		return oldValue1;
	}

	/**
	 * @param value2
	 * @return the old value2
	 */
	public T2 setValue2(T2 value2) {
		T2 oldValue2 = this.value2;
		this.value2 = value2;
		return oldValue2;
	}

	/**
	 * @param value1
	 * @param value2
	 * @return the old values
	 */
	public Tupel<T1, T2> setValues(T1 value1, T2 value2) {
		Tupel<T1, T2> oldValue = new Tupel<T1, T2>(this.value1, this.value2);
		this.value1 = value1;
		this.value2 = value2;
		return oldValue;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see java.lang.Object#hashCode()
	 */

	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((value1 == null) ? 0 : value1.hashCode());
		result = prime * result + ((value2 == null) ? 0 : value2.hashCode());
		return result;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see java.lang.Object#equals(java.lang.Object)
	 */
	@SuppressWarnings("unchecked")
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (!(obj instanceof Tupel))
			return false;
		Tupel<T1, T2> other = (Tupel<T1, T2>) obj;
		if (value1 == null) {
			if (other.value1 != null)
				return false;
		} else if (!value1.equals(other.value1))
			return false;
		if (value2 == null) {
			if (other.value2 != null)
				return false;
		} else if (!value2.equals(other.value2))
			return false;
		return true;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see java.lang.Object#toString()
	 */

	public String toString() {
		return this.value1.toString() + ":" + this.value2.toString();
	}
}
