/**
 * 
 */
package com.wieseke.cptk.main;

import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.OutputStreamWriter;

import org.apache.commons.io.FileUtils;

import com.wieseke.cptk.common.exceptions.SerializeException;
import com.wieseke.cptk.common.log.CophylogenyLogger;
import com.wieseke.cptk.input.dao.InputCophylogeny;
import com.wieseke.cptk.input.format.nexus.NexusDeserializer;
import com.wieseke.cptk.input.format.nexus.TreeSerializer;

/**
 * @author Nicolas Wieseke
 * 
 */
public class ConversionNexToTxt {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		try {
			String filename = args[0];
			NexusDeserializer nd = new NexusDeserializer();
			InputCophylogeny cophylogeny = nd.deserialize(new FileInputStream(
					filename), filename);
			cophylogeny.deleteNoneLeafAssociations(cophylogeny
					.getParasiteRoot());

			try {
				OutputStreamWriter ow = new OutputStreamWriter(
						FileUtils.openOutputStream(new File(args[0]
								+ ".org.txt")));
				TreeSerializer ts = new TreeSerializer();
				// delete internal node associations
				cophylogeny.deleteNoneLeafAssociations(cophylogeny
						.getParasiteRoot());
				ow.write(ts.serialize(cophylogeny));
				ow.flush();
				ow.close();
			} catch (SerializeException e) {
				CophylogenyLogger.logError(e);
			} catch (IOException e) {
				CophylogenyLogger.logError(e);
			}

		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	/**
	 * prints the help information
	 * */
	static public void printHelp() {
		System.out
				.println("\nSyntax:\n"
						+ "java -cp .:./* com.wieseke.cptk.main.Reconstruction [filename.nex] [0|1|2|all]"
						+ "\n\nFor the java -cp parameter use ';' as classpath separanor on Windows machines (not ':').");
	}
}
