/**
 * 
 */
package com.wieseke.cptk.output.action;

import org.eclipse.jface.viewers.ISelection;
import org.eclipse.ui.IWorkbenchPart;

import com.wieseke.cptk.common.action.CommonAction;
import com.wieseke.cptk.common.selection.CophylogenyViewerSelection;
import com.wieseke.cptk.common.viewer.CophylogenyViewer;
import com.wieseke.cptk.output.selection.OutputNodeControlSelection;
import com.wieseke.cptk.output.viewer.OutputCophylogenyViewer;
import com.wieseke.cptk.output.viewer.OutputNodeControl;

/**
 * @author Nicolas Wieseke
 * 
 */
public abstract class OutputAction extends CommonAction {

	/**
	 * the output node control
	 */
	protected OutputNodeControl node;

	/**
	 * constructor
	 * 
	 * @param text
	 */
	public OutputAction(String text) {
		super(text);
		setEnabled(false);
	}

	/**
	 * constructor
	 * 
	 * @param text
	 * @param style
	 */
	public OutputAction(String text, int style) {
		super(text, style);
		setEnabled(false);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see
	 * com.wieseke.cptk.common.action.CommonAction#selectionChanged(org.eclipse
	 * .ui.IWorkbenchPart, org.eclipse.jface.viewers.ISelection)
	 */
	
	public void selectionChanged(IWorkbenchPart part, ISelection selection) {
		this.part = part;
		if (!selection.isEmpty()) {
			if (selection instanceof CophylogenyViewerSelection) {
				CophylogenyViewer viewer = ((CophylogenyViewerSelection) selection)
						.getCophylogenyViewer();
				if (viewer instanceof OutputCophylogenyViewer) {
					this.viewer = viewer;
				}
			}
			if (selection instanceof OutputNodeControlSelection) {
				this.node = ((OutputNodeControlSelection) selection)
						.getOutputNodeControl();
			}
		}
	}

	/**
	 * @return the viewer
	 */
	protected OutputCophylogenyViewer getViewer() {
		return (OutputCophylogenyViewer) this.viewer;
	}
}
