/**
 * 
 */
package com.wieseke.cptk.output.action;

import org.eclipse.jface.resource.ImageDescriptor;

import com.wieseke.cptk.app.CPTKApplication;
import com.wieseke.cptk.output.constants.OutputActionConstants;

/**
 * @author Nicolas Wieseke
 * 
 */
public abstract class OutputNodeControlActionFactory {

	// node actions
	public static final OutputNodeControlActionFactory FOLD_NODE = new OutputNodeControlActionFactory() {
		public OutputAction create() {

			OutputAction action = new EditFoldNodeAction();
			action.setId(OutputActionConstants.FOLD_NODE_ID);
			action.setImageDescriptor(ImageDescriptor.createFromFile(
					CPTKApplication.class,
					OutputActionConstants.FOLD_NODE_IMAGEPATH));
			action.setToolTipText(OutputActionConstants.FOLD_NODE_TOOLTIPTEXT);
			return action;
		}
	};

	public static final OutputNodeControlActionFactory CHANGE_LABEL = new OutputNodeControlActionFactory() {
		public OutputAction create() {

			OutputAction action = new EditChangeLabelAction();
			action.setId(OutputActionConstants.CHANGE_LABEL_ID);
			action.setImageDescriptor(ImageDescriptor.createFromFile(
					CPTKApplication.class,
					OutputActionConstants.CHANGE_LABEL_IMAGEPATH));
			action
					.setToolTipText(OutputActionConstants.CHANGE_LABEL_TOOLTIPTEXT);
			return action;
		}
	};

	public abstract OutputAction create();
}
