/**
 * 
 */
package com.wieseke.cptk.output.editor;

import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.ui.IEditorInput;
import org.eclipse.ui.IPersistableElement;

import com.wieseke.cptk.reconstruction.dao.ReconstructionCophylogeny;

/**
 * @author Nicolas Wieseke
 * 
 */
public class VisualOutputEditorInput implements IEditorInput {

	private ReconstructionCophylogeny cophylogeny;

	public VisualOutputEditorInput(ReconstructionCophylogeny cophylogeny) {
		this.setCophylogeny(cophylogeny);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.ui.IEditorInput#exists()
	 */

	public boolean exists() {
		return false;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.ui.IEditorInput#getImageDescriptor()
	 */

	public ImageDescriptor getImageDescriptor() {
		return null;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.ui.IEditorInput#getName()
	 */

	public String getName() {
		return "R:"
				+ this.cophylogeny.getFilename().substring(
						this.cophylogeny.getFilename().lastIndexOf("/") + 1);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.ui.IEditorInput#getPersistable()
	 */

	public IPersistableElement getPersistable() {
		return null;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.ui.IEditorInput#getToolTipText()
	 */

	public String getToolTipText() {
		return "R:"
				+ this.cophylogeny.getFilename().substring(
						this.cophylogeny.getFilename().lastIndexOf("/") + 1);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.core.runtime.IAdaptable#getAdapter(java.lang.Class)
	 */
	@SuppressWarnings("rawtypes")
	public Object getAdapter(Class adapter) {
		return null;
	}

	public void setCophylogeny(ReconstructionCophylogeny cophylogeny) {
		this.cophylogeny = cophylogeny;
	}

	public ReconstructionCophylogeny getCophylogeny() {
		return cophylogeny;
	}

}
