/**
 * 
 */
package com.wieseke.cptk.output.preferences;

import org.eclipse.jface.preference.ColorFieldEditor;
import org.eclipse.jface.preference.FieldEditorPreferencePage;
import org.eclipse.jface.preference.FontFieldEditor;
import org.eclipse.jface.preference.IntegerFieldEditor;
import org.eclipse.ui.IWorkbench;
import org.eclipse.ui.IWorkbenchPreferencePage;
import org.eclipse.ui.PlatformUI;

/**
 * @author Nicolas Wieseke
 * 
 */
public class OutputParasitePreferencePage extends FieldEditorPreferencePage
		implements IWorkbenchPreferencePage {

	public OutputParasitePreferencePage() {
		super(GRID);
	}

	private IntegerFieldEditor parasiteLineWidth;
	private ColorFieldEditor parasiteLineColor;
	private IntegerFieldEditor parasiteNodeWidth;
	private IntegerFieldEditor parasiteNodeHeight;
	private ColorFieldEditor parasiteNodeColor;
	private ColorFieldEditor parasiteNodeOutlineColor;
	private ColorFieldEditor parasiteNodHighlightColor;
	private ColorFieldEditor parasiteNodeFoldSignColor;
	private FontFieldEditor parasiteFont;
	private ColorFieldEditor parasiteFontColor;

	/*
	 * (non-Javadoc)
	 * 
	 * @see
	 * org.eclipse.jface.preference.FieldEditorPreferencePage#createFieldEditors
	 * ()
	 */
	
	protected void createFieldEditors() {
		this.parasiteNodeWidth = new IntegerFieldEditor(
				OutputPreferenceConstants.OUTPUT_VIEWER_NAME_PARASITE_NODEWIDTH,
				OutputPreferenceConstants.OUTPUT_VIEWER_PARASITE_NODEWIDTH_TEXT,
				getFieldEditorParent());
		addField(this.parasiteNodeWidth);
		this.parasiteNodeHeight = new IntegerFieldEditor(
				OutputPreferenceConstants.OUTPUT_VIEWER_NAME_PARASITE_NODEHEIGHT,
				OutputPreferenceConstants.OUTPUT_VIEWER_PARASITE_NODEHEIGHT_TEXT,
				getFieldEditorParent());
		addField(this.parasiteNodeHeight);

		this.parasiteLineWidth = new IntegerFieldEditor(
				OutputPreferenceConstants.OUTPUT_VIEWER_NAME_PARASITE_LINEWIDTH,
				OutputPreferenceConstants.OUTPUT_VIEWER_PARASITE_LINEWIDTH_TEXT,
				getFieldEditorParent());
		addField(this.parasiteLineWidth);
		this.parasiteLineColor = new ColorFieldEditor(
				OutputPreferenceConstants.OUTPUT_VIEWER_NAME_PARASITE_LINECOLOR,
				OutputPreferenceConstants.OUTPUT_VIEWER_PARASITE_LINECOLOR_TEXT,
				getFieldEditorParent());
		addField(this.parasiteLineColor);

		this.parasiteNodeColor = new ColorFieldEditor(
				OutputPreferenceConstants.OUTPUT_VIEWER_NAME_PARASITE_NODECOLOR,
				OutputPreferenceConstants.OUTPUT_VIEWER_PARASITE_NODECOLOR_TEXT,
				getFieldEditorParent());
		addField(this.parasiteNodeColor);
		this.parasiteNodeOutlineColor = new ColorFieldEditor(
				OutputPreferenceConstants.OUTPUT_VIEWER_NAME_PARASITE_NODEOUTLINECOLOR,
				OutputPreferenceConstants.OUTPUT_VIEWER_PARASITE_NODEOUTLINECOLOR_TEXT,
				getFieldEditorParent());
		addField(this.parasiteNodeOutlineColor);
		this.parasiteNodHighlightColor = new ColorFieldEditor(
				OutputPreferenceConstants.OUTPUT_VIEWER_NAME_PARASITE_NODEHIGHLIGHTCOLOR,
				OutputPreferenceConstants.OUTPUT_VIEWER_PARASITE_NODEHIGHLIGHTCOLOR_TEXT,
				getFieldEditorParent());
		addField(this.parasiteNodHighlightColor);
		this.parasiteNodeFoldSignColor = new ColorFieldEditor(
				OutputPreferenceConstants.OUTPUT_VIEWER_NAME_PARASITE_NODEFOLDSIGNCOLOR,
				OutputPreferenceConstants.OUTPUT_VIEWER_PARASITE_NODEFOLDSIGNCOLOR_TEXT,
				getFieldEditorParent());
		addField(this.parasiteNodeFoldSignColor);

		this.parasiteFontColor = new ColorFieldEditor(
				OutputPreferenceConstants.OUTPUT_VIEWER_NAME_PARASITE_FONTCOLOR,
				OutputPreferenceConstants.OUTPUT_VIEWER_PARASITE_FONTCOLOR_TEXT,
				getFieldEditorParent());
		addField(this.parasiteFontColor);
		this.parasiteFont = new FontFieldEditor(
				OutputPreferenceConstants.OUTPUT_VIEWER_NAME_PARASITE_FONT,
				OutputPreferenceConstants.OUTPUT_VIEWER_PARASITE_FONT_TEXT,
				getFieldEditorParent());
		addField(parasiteFont);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see
	 * org.eclipse.ui.IWorkbenchPreferencePage#init(org.eclipse.ui.IWorkbench)
	 */
	
	public void init(IWorkbench workbench) {
		setPreferenceStore(PlatformUI.getPreferenceStore());
		setDescription("Preferences for visualizing of parasite nodes in the reconstructions");
	}

}
