package com.wieseke.cptk.output.selection;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import org.eclipse.jface.viewers.IStructuredSelection;

import com.wieseke.cptk.output.viewer.OutputNodeControl;

public class OutputNodeControlSelection implements IStructuredSelection {

	private OutputNodeControl outputNodeControl;

	public OutputNodeControlSelection(OutputNodeControl canvas) {
		this.outputNodeControl = canvas;
	}

	public OutputNodeControlSelection() {
		this.outputNodeControl = null;
	}

	
	public boolean isEmpty() {
		return (outputNodeControl == null);
	}

	/**
	 * @return the outputNodeControl
	 */
	public OutputNodeControl getOutputNodeControl() {
		return outputNodeControl;
	}

	/**
	 * @param outputNodeControl
	 *            the outputNodeControl to set
	 */
	public void setOutputNodeControl(OutputNodeControl outputNodeControl) {
		this.outputNodeControl = outputNodeControl;
	}

	
	public Object getFirstElement() {
		return this.outputNodeControl;
	}

	
	public Iterator<?> iterator() {
		Iterator<OutputNodeControl> iterator = new Iterator<OutputNodeControl>() {
			boolean hasNext = true;

			
			public boolean hasNext() {
				return hasNext;
			}

			
			public OutputNodeControl next() {
				if (hasNext) {
					hasNext = false;
					return OutputNodeControlSelection.this.outputNodeControl;
				}
				return null;
			}

			
			public void remove() {
				hasNext = false;
			}
		};
		return iterator;
	}

	
	public int size() {
		return this.outputNodeControl == null ? 0 : 1;
	}

	
	public Object[] toArray() {
		OutputNodeControl[] result = { this.outputNodeControl };
		return result;
	}

	
	public List<?> toList() {
		List<OutputNodeControl> result = new ArrayList<OutputNodeControl>();
		result.add(this.outputNodeControl);
		return result;
	}
}
