/**
 * 
 */
package com.wieseke.cptk.output.wizards;

import org.eclipse.jface.wizard.Wizard;

import com.wieseke.cptk.output.dao.OutputCophylogeny;
import com.wieseke.cptk.output.dao.OutputNode;

/**
 * @author Nicolas Wieseke
 * 
 */
public class ChangeLabelWizard extends Wizard {

	private ChangeLabelWizardPage changeLabelWizardPage;
	private OutputNode node;
	private OutputCophylogeny cophylogeny;
	private String label;

	public ChangeLabelWizard(OutputNode node, OutputCophylogeny cophylogeny) {
		this.node = node;
		this.cophylogeny = cophylogeny;
	}

	
	public boolean performFinish() {
		label = changeLabelWizardPage.getLabel();
		if (label.length() == 0) {
			this.changeLabelWizardPage.setDescription("The label must not be empty.");
			return false;
		} else if (!this.cophylogeny.checkNodeLabel(label, this.node)) {
			this.changeLabelWizardPage.setDescription("The label must not be used by an other node.");
			return false;
		}
		return true;
	}

	
	public void addPages() {
		changeLabelWizardPage = new ChangeLabelWizardPage("Change label", this.node.getLabel());
		addPage(changeLabelWizardPage);
		super.addPages();
	}

	/**
	 * @return the label
	 */
	public String getLabel() {
		return label;
	}

}
